Index: trunk/MagicSoft/TDAS-Extractor/TimeResVsCharge-Area-30.eps
===================================================================
--- trunk/MagicSoft/TDAS-Extractor/TimeResVsCharge-Area-30.eps	(revision 5664)
+++ trunk/MagicSoft/TDAS-Extractor/TimeResVsCharge-Area-30.eps	(revision 5896)
@@ -1,7 +1,7 @@
 %!PS-Adobe-2.0 EPSF-2.0
-%%BoundingBox:  0 0 567 384
-%%Title: ./timeplots/TimeResVsCharge-Area-30.eps: Conversion Factor vs. Charges
+%%BoundingBox:  0 0 567 544
+%%Title: ./timeplots/TimeResVsCharge-Area-30.eps: Time Resolution vs. Phes
 %%Creator: ROOT Version 3.10/02
-%%CreationDate: Tue Dec 21 12:05:45 2004
+%%CreationDate: Tue Jan 18 18:18:44 2005
 %%EndComments
 %%BeginProlog
@@ -80,88 +80,58 @@
 newpath  gsave  .25 .25 scale 
 %%EndSetup
- gsave  0 0 t black [] 0 sd 3 lw 1 1 1 c 2268 1538 0 0 bf black 1 1 1 c 1814 1230 227 154 bf black 1814 1230 227 154 bl 1 1 1 c 1814 1230 227 154 bf black 1814 1230 227 154 bl 227 154 m 1814 X s
- gsave  922 20
- t 0 r 0 0 m /Helvetica-Bold findfont 84.7135 sf 0 0 m (<Phes> [1]) show  gr  311 172 m -18 Y s [4 8] 0 sd 311 1384 m -1230 Y s [] 0 sd 376 172 m -18 Y s [4 8] 0 sd 376 1384 m -1230 Y s [] 0 sd 429 172 m -18 Y s [4 8] 0 sd 429 1384 m -1230 Y s
- [] 0 sd 474 172 m -18 Y s [4 8] 0 sd 474 1384 m -1230 Y s [] 0 sd 513 172 m -18 Y s [4 8] 0 sd 513 1384 m -1230 Y s [] 0 sd 547 172 m -18 Y s [4 8] 0 sd 547 1384 m -1230 Y s [] 0 sd 578 191 m -37 Y s [4 8] 0 sd 578 1384 m -1230 Y s
- /xs 0 def (10) /Helvetica-Bold 58.6478 stwn  gsave  578 75
- t 0 r xs 2 div neg 0 t 0 0 m /Helvetica-Bold findfont 58.6478 sf 0 0 m (10) show  gr  [] 0 sd 781 172 m -18 Y s [4 8] 0 sd 781 1384 m -1230 Y s [] 0 sd 899 172 m -18 Y s [4 8] 0 sd 899 1384 m -1230 Y s [] 0 sd 983 172 m -18 Y s [4 8] 0 sd 983 1384 m
- -1230 Y s [] 0 sd 1048 172 m -18 Y s [4 8] 0 sd 1048 1384 m -1230 Y s [] 0 sd 1101 172 m -18 Y s [4 8] 0 sd 1101 1384 m -1230 Y s [] 0 sd 1146 172 m -18 Y s [4 8] 0 sd 1146 1384 m -1230 Y s [] 0 sd 1185 172 m -18 Y s [4 8] 0 sd 1185 1384 m -1230 Y s
- [] 0 sd 1220 172 m -18 Y s [4 8] 0 sd 1220 1384 m -1230 Y s [] 0 sd 1250 191 m -37 Y s [4 8] 0 sd 1250 1384 m -1230 Y s
- gsave  1267 108
- t 0 r 0 0 m /Helvetica-Bold findfont 39.0986 sf 0 0 m (2) show  gr 
- gsave  1202 78
- t 0 r 0 0 m /Helvetica-Bold findfont 58.6478 sf 0 0 m (10) show  gr  [] 0 sd 1453 172 m -18 Y s [4 8] 0 sd 1453 1384 m -1230 Y s [] 0 sd 1571 172 m -18 Y s [4 8] 0 sd 1571 1384 m -1230 Y s [] 0 sd 1655 172 m -18 Y s [4 8] 0 sd 1655 1384 m -1230 Y s
- [] 0 sd 1720 172 m -18 Y s [4 8] 0 sd 1720 1384 m -1230 Y s [] 0 sd 1773 172 m -18 Y s [4 8] 0 sd 1773 1384 m -1230 Y s [] 0 sd 1818 172 m -18 Y s [4 8] 0 sd 1818 1384 m -1230 Y s [] 0 sd 1857 172 m -18 Y s [4 8] 0 sd 1857 1384 m -1230 Y s [] 0 sd
- 1892 172 m -18 Y s [4 8] 0 sd 1892 1384 m -1230 Y s [] 0 sd 1923 191 m -37 Y s [4 8] 0 sd 1923 1384 m -1230 Y s
- gsave  1942 108
- t 0 r 0 0 m /Helvetica-Bold findfont 39.0986 sf 0 0 m (3) show  gr 
- gsave  1877 78
- t 0 r 0 0 m /Helvetica-Bold findfont 58.6478 sf 0 0 m (10) show  gr  [] 0 sd 227 154 m 1230 Y s
- gsave  101 355
- t 90 r 0 0 m /Helvetica-Bold findfont 84.7135 sf 0 0 m (Time Resolution [ns]) show  gr  281 154 m -54 X s [4 8] 0 sd 2041 154 m -1814 X s [] 0 sd 254 181 m -27 X s 254 208 m -27 X s 254 236 m -27 X s 254 263 m -27 X s 281 290 m -54 X s [4 8] 0 sd
- 2041 290 m -1814 X s [] 0 sd 254 318 m -27 X s 254 345 m -27 X s 254 373 m -27 X s 254 400 m -27 X s 281 427 m -54 X s [4 8] 0 sd 2041 427 m -1814 X s [] 0 sd 254 455 m -27 X s 254 482 m -27 X s 254 509 m -27 X s 254 537 m -27 X s 281 564 m -54 X s
- [4 8] 0 sd 2041 564 m -1814 X s [] 0 sd 254 591 m -27 X s 254 619 m -27 X s 254 646 m -27 X s 254 673 m -27 X s 281 701 m -54 X s [4 8] 0 sd 2041 701 m -1814 X s [] 0 sd 254 728 m -27 X s 254 755 m -27 X s 254 783 m -27 X s 254 810 m -27 X s 281 837
- m -54 X s [4 8] 0 sd 2041 837 m -1814 X s [] 0 sd 254 865 m -27 X s 254 892 m -27 X s 254 919 m -27 X s 254 947 m -27 X s 281 974 m -54 X s [4 8] 0 sd 2041 974 m -1814 X s [] 0 sd 254 1001 m -27 X s 254 1029 m -27 X s 254 1056 m -27 X s 254 1083 m
- -27 X s 281 1111 m -54 X s [4 8] 0 sd 2041 1111 m -1814 X s [] 0 sd 254 1138 m -27 X s 254 1165 m -27 X s 254 1193 m -27 X s 254 1220 m -27 X s 281 1247 m -54 X s [4 8] 0 sd 2041 1247 m -1814 X s [] 0 sd 254 1275 m -27 X s 254 1302 m -27 X s 254
- 1329 m -27 X s 254 1357 m -27 X s 281 1384 m -54 X s [4 8] 0 sd 2041 1384 m -1814 X s
- gsave  182 140
- t 0 r 0 0 m /Helvetica-Bold findfont 58.6478 sf 0 0 m (0) show  gr 
- gsave  134 277
- t 0 r 0 0 m /Helvetica-Bold findfont 58.6478 sf 0 0 m (0.5) show  gr 
- gsave  189 414
- t 0 r 0 0 m /Helvetica-Bold findfont 58.6478 sf 0 0 m (1) show  gr 
- gsave  134 551
- t 0 r 0 0 m /Helvetica-Bold findfont 58.6478 sf 0 0 m (1.5) show  gr 
- gsave  182 687
- t 0 r 0 0 m /Helvetica-Bold findfont 58.6478 sf 0 0 m (2) show  gr 
- gsave  134 821
- t 0 r 0 0 m /Helvetica-Bold findfont 58.6478 sf 0 0 m (2.5) show  gr 
- gsave  182 958
- t 0 r 0 0 m /Helvetica-Bold findfont 58.6478 sf 0 0 m (3) show  gr 
- gsave  134 1095
- t 0 r 0 0 m /Helvetica-Bold findfont 58.6478 sf 0 0 m (3.5) show  gr 
- gsave  182 1232
- t 0 r 0 0 m /Helvetica-Bold findfont 58.6478 sf 0 0 m (4) show  gr 
- gsave  134 1368
- t 0 r 0 0 m /Helvetica-Bold findfont 58.6478 sf 0 0 m (4.5) show  gr  [] 0 sd 1538 252 m s 1532 252 m 13 X s 1538 213 m -1 Y s 1532 212 m 13 X s 806 396 m 10 Y s 800 406 m 13 X s 806 357 m -10 Y s 800 347 m 13 X s 814 375 m 3 Y s 807 378 m 13 X s
- 814 336 m -2 Y s 807 334 m 13 X s 459 1220 m 47 Y s 452 1267 m 13 X s 459 1181 m -47 Y s 452 1134 m 13 X s 0.2 1 0.2 c /w 39 def /w2 {w 2 div} def /w3 {w 3 div} def 1538 232 806 376 814 356 459 1201 4 { m22} R black 1177 327 m 4 Y s 1170 331 m 13 X
- s 1177 288 m -4 Y s 1170 284 m 13 X s 1187 316 m 2 Y s 1180 318 m 13 X s 1187 277 m -1 Y s 1180 276 m 13 X s 1186 319 m 2 Y s 1179 321 m 13 X s 1186 280 m -1 Y s 1179 279 m 13 X s 1022 320 m 4 Y s 1015 324 m 13 X s 1022 281 m -3 Y s 1015 278 m 13 X
- s 451 1236 m 41 Y s 445 1277 m 13 X s 451 1197 m -41 Y s 445 1156 m 13 X s 924 339 m 8 Y s 918 347 m 13 X s 924 300 m -7 Y s 918 293 m 13 X s 1223 308 m 1 Y s 1216 309 m 14 X s 1223 269 m -1 Y s 1216 268 m 14 X s 1374 276 m s 1367 276 m 13 X s 1374
- 237 m -1 Y s 1367 236 m 13 X s 0 0.36 1 c 1177 307 1187 297 1186 300 1022 301 451 1217 924 320 1223 289 1374 256 8 { m24} R black 365 1043 m 52 Y s 359 1095 m 13 X s 365 1004 m -52 Y s 359 952 m 13 X s 619 425 m 8 Y s 613 433 m 13 X s 619 386 m -7 Y
- s 613 379 m 13 X s 767 356 m 16 Y s 761 372 m 13 X s 767 317 m -17 Y s 761 300 m 13 X s 789 354 m 23 Y s 783 377 m 13 X s 789 315 m -23 Y s 783 292 m 13 X s 1 0.2 1 c 365 1024 619 406 767 336 789 335 4 { m26} R black 0.95 0.95 0.95 c 794 384 1247
- 923 bf black 1267 923 m -13 Y 787 X 378 Y -13 X -365 Y f 1247 923 m 384 Y 794 X -384 Y -794 X cl s
- gsave  1443 1264
- t 0 r 0 0 m /Helvetica findfont 42.3568 sf 0 0 m (Green Pulses Inner Pixels) show  gr  0.2 1 0.2 c 1346 1275 m22 black
- gsave  1443 1199
- t 0 r 0 0 m /Helvetica findfont 42.3568 sf 0 0 m (Blue Pulses Inner Pixels) show  gr  0 0.36 1 c 1346 1211 m24 black
- gsave  1443 1137
- t 0 r 0 0 m /Helvetica findfont 42.3568 sf 0 0 m (UV Pulses Inner Pixels) show  gr  1 0.2 1 c 1346 1147 m26 black
- gsave  1443 1072
- t 0 r 0 0 m /Helvetica findfont 42.3568 sf 0 0 m (Green Pulses Outer Pixels) show  gr  0.2 1 0.2 c 1346 1083 m23 black
- gsave  1443 1007
- t 0 r 0 0 m /Helvetica findfont 42.3568 sf 0 0 m (Blue Pulses Outer Pixels) show  gr  0 0.36 1 c 1346 1019 m25 black
- gsave  1443 945
- t 0 r 0 0 m /Helvetica findfont 42.3568 sf 0 0 m (UV Pulses Outer Pixels) show  gr  1 0.2 1 c 1346 955 m27 black 0.95 0.95 0.95 c 2041 154 23 1376 bf black 32 1376 m -6 Y 2038 X 150 Y -6 X -144 Y f 23 1376 m 154 Y 2041 X -154 Y -2041 X cl s 1 1 1 c
- black
- gsave  375 1414
- t 0 r 0 0 m /Helvetica-Bold findfont 120.554 sf 0 0 m (All Pixels - Extractor 30) show  gr  1662 252 m 4 Y s 1655 256 m 13 X s 1662 213 m -4 Y s 1655 209 m 13 X s 1090 371 m s 1083 371 m 13 X s 1090 331 m s 1083 331 m 13 X s 1099 359 m 4 Y s 1092
- 363 m 13 X s 1099 320 m -4 Y s 1092 316 m 13 X s 694 1090 m 26 Y s 688 1116 m 13 X s 694 1051 m -26 Y s 688 1025 m 13 X s 0.2 1 0.2 c 1662 232 1090 351 1099 340 694 1070 4 { m23} R black 1385 317 m 1 Y s 1379 318 m 13 X s 1385 278 m s 1379 278 m 13
- X s 1397 312 m 2 Y s 1391 314 m 13 X s 1397 273 m -2 Y s 1391 271 m 13 X s 1397 314 m 1 Y s 1391 315 m 13 X s 1397 275 m -2 Y s 1391 273 m 13 X s 1286 317 m 3 Y s 1280 320 m 13 X s 1286 278 m -4 Y s 1280 274 m 13 X s 675 1102 m 19 Y s 669 1121 m 13
- X s 675 1063 m -19 Y s 669 1044 m 13 X s 1203 330 m 2 Y s 1197 332 m 13 X s 1203 290 m -2 Y s 1197 288 m 13 X s 1431 303 m 2 Y s 1425 305 m 13 X s 1431 264 m -2 Y s 1425 262 m 13 X s 1554 274 m 13 Y s 1547 287 m 13 X s 1554 235 m -13 Y s 1547 222 m
- 13 X s 0 0.36 1 c 1385 298 1397 292 1397 294 1286 297 675 1082 1203 310 1431 284 1554 254 8 { m25} R black 619 907 m 33 Y s 612 940 m 13 X s 619 868 m -34 Y s 612 834 m 13 X s 903 389 m 8 Y s 896 397 m 13 X s 903 350 m -8 Y s 896 342 m 13 X s 1054
- 344 m 5 Y s 1047 349 m 13 X s 1054 305 m -5 Y s 1047 300 m 13 X s 1072 341 m 5 Y s 1065 346 m 13 X s 1072 302 m -5 Y s 1065 297 m 13 X s 1 0.2 1 c 619 887 903 369 1054 325 1072 321 4 { m27} R black 0.95 0.95 0.95 c 794 384 1247 923 bf black 1267 923
- m -13 Y 787 X 378 Y -13 X -365 Y f 1247 923 m 384 Y 794 X -384 Y -794 X cl s
- gsave  1443 1264
- t 0 r 0 0 m /Helvetica findfont 42.3568 sf 0 0 m (Green Pulses Inner Pixels) show  gr  0.2 1 0.2 c 1346 1275 m22 black
- gsave  1443 1199
- t 0 r 0 0 m /Helvetica findfont 42.3568 sf 0 0 m (Blue Pulses Inner Pixels) show  gr  0 0.36 1 c 1346 1211 m24 black
- gsave  1443 1137
- t 0 r 0 0 m /Helvetica findfont 42.3568 sf 0 0 m (UV Pulses Inner Pixels) show  gr  1 0.2 1 c 1346 1147 m26 black
- gsave  1443 1072
- t 0 r 0 0 m /Helvetica findfont 42.3568 sf 0 0 m (Green Pulses Outer Pixels) show  gr  0.2 1 0.2 c 1346 1083 m23 black
- gsave  1443 1007
- t 0 r 0 0 m /Helvetica findfont 42.3568 sf 0 0 m (Blue Pulses Outer Pixels) show  gr  0 0.36 1 c 1346 1019 m25 black
- gsave  1443 945
- t 0 r 0 0 m /Helvetica findfont 42.3568 sf 0 0 m (UV Pulses Outer Pixels) show  gr  1 0.2 1 c 1346 955 m27
+ gsave  0 0 t black [] 0 sd 3 lw 1 1 1 c 2268 2176 0 0 bf black 1 1 1 c 1814 1741 227 218 bf black 1814 1741 227 218 bl 1 1 1 c 1814 1741 227 218 bf black 1814 1741 227 218 bl 227 218 m 1814 X s
+ gsave  932 49
+ t 0 r 0 0 m /Helvetica-Bold findfont 79.9028 sf 0 0 m (<Phes> [1]) show  gr  307 244 m -26 Y s [4 8] 0 sd 307 1959 m -1741 Y s [] 0 sd 369 244 m -26 Y s [4 8] 0 sd 369 1959 m -1741 Y s [] 0 sd 420 244 m -26 Y s [4 8] 0 sd 420 1959 m -1741 Y s
+ [] 0 sd 463 244 m -26 Y s [4 8] 0 sd 463 1959 m -1741 Y s [] 0 sd 500 244 m -26 Y s [4 8] 0 sd 500 1959 m -1741 Y s [] 0 sd 533 244 m -26 Y s [4 8] 0 sd 533 1959 m -1741 Y s [] 0 sd 563 270 m -52 Y s [4 8] 0 sd 563 1959 m -1741 Y s
+ /xs 0 def (10) /Helvetica-Bold 79.9028 stwn  gsave  563 107
+ t 0 r xs 2 div neg 0 t 0 0 m /Helvetica-Bold findfont 79.9028 sf 0 0 m (10) show  gr  [] 0 sd 756 244 m -26 Y s [4 8] 0 sd 756 1959 m -1741 Y s [] 0 sd 869 244 m -26 Y s [4 8] 0 sd 869 1959 m -1741 Y s [] 0 sd 949 244 m -26 Y s [4 8] 0 sd 949 1959 m
+ -1741 Y s [] 0 sd 1012 244 m -26 Y s [4 8] 0 sd 1012 1959 m -1741 Y s [] 0 sd 1063 244 m -26 Y s [4 8] 0 sd 1063 1959 m -1741 Y s [] 0 sd 1106 244 m -26 Y s [4 8] 0 sd 1106 1959 m -1741 Y s [] 0 sd 1143 244 m -26 Y s [4 8] 0 sd 1143 1959 m -1741 Y s
+ [] 0 sd 1176 244 m -26 Y s [4 8] 0 sd 1176 1959 m -1741 Y s [] 0 sd 1205 270 m -52 Y s [4 8] 0 sd 1205 1959 m -1741 Y s
+ gsave  1229 152
+ t 0 r 0 0 m /Helvetica-Bold findfont 53.2685 sf 0 0 m (2) show  gr 
+ gsave  1141 110
+ t 0 r 0 0 m /Helvetica-Bold findfont 79.9028 sf 0 0 m (10) show  gr  [] 0 sd 1399 244 m -26 Y s [4 8] 0 sd 1399 1959 m -1741 Y s [] 0 sd 1512 244 m -26 Y s [4 8] 0 sd 1512 1959 m -1741 Y s [] 0 sd 1592 244 m -26 Y s [4 8] 0 sd 1592 1959 m -1741 Y s
+ [] 0 sd 1654 244 m -26 Y s [4 8] 0 sd 1654 1959 m -1741 Y s [] 0 sd 1705 244 m -26 Y s [4 8] 0 sd 1705 1959 m -1741 Y s [] 0 sd 1748 244 m -26 Y s [4 8] 0 sd 1748 1959 m -1741 Y s [] 0 sd 1785 244 m -26 Y s [4 8] 0 sd 1785 1959 m -1741 Y s [] 0 sd
+ 1818 244 m -26 Y s [4 8] 0 sd 1818 1959 m -1741 Y s [] 0 sd 1848 270 m -52 Y s [4 8] 0 sd 1848 1959 m -1741 Y s
+ gsave  1872 152
+ t 0 r 0 0 m /Helvetica-Bold findfont 53.2685 sf 0 0 m (3) show  gr 
+ gsave  1784 110
+ t 0 r 0 0 m /Helvetica-Bold findfont 79.9028 sf 0 0 m (10) show  gr  [] 0 sd 227 218 m 1741 Y s
+ gsave  72 696
+ t 90 r 0 0 m /Helvetica-Bold findfont 79.9028 sf 0 0 m (Time Resolution [ns]) show  gr  281 218 m -54 X s [4 8] 0 sd 2041 218 m -1814 X s
+ gsave  175 228
+ t 0 r 0 0 m /Helvetica-Bold findfont 53.2685 sf 0 0 m (-1) show  gr 
+ gsave  88 190
+ t 0 r 0 0 m /Helvetica-Bold findfont 79.9028 sf 0 0 m (10) show  gr  [] 0 sd 254 497 m -27 X s [4 8] 0 sd 2041 497 m -1814 X s [] 0 sd 254 661 m -27 X s [4 8] 0 sd 2041 661 m -1814 X s [] 0 sd 254 777 m -27 X s [4 8] 0 sd 2041 777 m -1814 X s
+ [] 0 sd 254 867 m -27 X s [4 8] 0 sd 2041 867 m -1814 X s [] 0 sd 254 940 m -27 X s [4 8] 0 sd 2041 940 m -1814 X s [] 0 sd 254 1002 m -27 X s [4 8] 0 sd 2041 1002 m -1814 X s [] 0 sd 254 1056 m -27 X s [4 8] 0 sd 2041 1056 m -1814 X s [] 0 sd 254
+ 1104 m -27 X s [4 8] 0 sd 2041 1104 m -1814 X s [] 0 sd 281 1146 m -54 X s [4 8] 0 sd 2041 1146 m -1814 X s
+ /xs 0 def (1) /Helvetica-Bold 79.9028 stwn  gsave  220 1113
+ t 0 r  xs neg 0 t 0 0 m /Helvetica-Bold findfont 79.9028 sf 0 0 m (1) show  gr  [] 0 sd 254 1426 m -27 X s [4 8] 0 sd 2041 1426 m -1814 X s [] 0 sd 254 1589 m -27 X s [4 8] 0 sd 2041 1589 m -1814 X s [] 0 sd 254 1705 m -27 X s [4 8] 0 sd 2041 1705 m
+ -1814 X s [] 0 sd 254 1795 m -27 X s [4 8] 0 sd 2041 1795 m -1814 X s [] 0 sd 254 1869 m -27 X s [4 8] 0 sd 2041 1869 m -1814 X s [] 0 sd 254 1931 m -27 X s [4 8] 0 sd 2041 1931 m -1814 X s [] 0 sd 2041 218 m 1741 Y s 1987 218 m 54 X s 2014 497 m 27
+ X s 2014 661 m 27 X s 2014 777 m 27 X s 2014 867 m 27 X s 2014 940 m 27 X s 2014 1002 m 27 X s 2014 1056 m 27 X s 2014 1104 m 27 X s 1987 1146 m 54 X s 2014 1426 m 27 X s 2014 1589 m 27 X s 2014 1705 m 27 X s 2014 1795 m 27 X s 2014 1869 m 27 X s
+ 2014 1931 m 27 X s 1722 476 m 38 Y s 1714 514 m 15 X s 1722 430 m -50 Y s 1714 380 m 15 X s 399 1431 m 136 Y s 391 1567 m 15 X s 399 1385 m -242 Y s 391 1143 m 15 X s 0.2 1 0.2 c /w 39 def /w2 {w 2 div} def /w3 {w 3 div} def 1722 453 735 910 757 867
+ 399 1408 4 { m22} R black 1723 482 m 33 Y s 1715 515 m 16 X s 1723 436 m -41 Y s 1715 395 m 16 X s 1213 786 m 5 Y s 1205 791 m 15 X s 1213 740 m -8 Y s 1205 732 m 15 X s 1217 786 m 15 Y s 1210 801 m 15 X s 1217 740 m -19 Y s 1210 721 m 15 X s 1183
+ 776 m 12 Y s 1176 788 m 15 X s 1183 730 m -14 Y s 1176 716 m 15 X s 914 746 m 16 Y s 906 762 m 15 X s 914 700 m -20 Y s 906 680 m 15 X s 1239 765 m 17 Y s 1232 782 m 15 X s 1239 719 m -22 Y s 1232 697 m 15 X s 1491 614 m 19 Y s 1483 633 m 16 X s
+ 1491 569 m -23 Y s 1483 546 m 16 X s 0 0.36 1 c 1723 459 1213 763 1217 763 1183 753 914 723 393 1552 858 786 1239 742 1491 592 9 { m24} R black 322 1212 m 268 Y s 314 1480 m 15 X s 322 1166 m -948 Y s 314 218 m 15 X s 1 0.2 1 c 322 1189 595 953 737
+ 824 754 820 4 { m26} R black 0 0.36 1 c black 1974 475 m 24 Y s 1966 499 m 15 X s 1974 430 m -30 Y s 1966 400 m 15 X s 629 1263 m 29 Y s 622 1292 m 15 X s 629 1217 m -37 Y s 622 1180 m 15 X s 0.2 1 0.2 c 1974 453 1013 844 1032 805 629 1240 4 { m23
+} R black 1971 466 m 21 Y s 1963 487 m 15 X s 1971 420 m -27 Y s 1963 393 m 15 X s 1521 754 m 10 Y s 1513 764 m 15 X s 1521 708 m -14 Y s 1513 694 m 15 X s 1527 764 m 13 Y s 1519 777 m 15 X s 1527 719 m -17 Y s 1519 702 m 15 X s 1525 754 m 11 Y s
+ 1517 765 m 15 X s 1525 708 m -14 Y s 1517 694 m 15 X s 1298 707 m 21 Y s 1290 728 m 16 X s 1298 661 m -26 Y s 1290 635 m 16 X s 613 1379 m 48 Y s 606 1427 m 15 X s 613 1334 m -63 Y s 606 1271 m 15 X s 1132 755 m s 1124 755 m 16 X s 1132 709 m -2 Y s
+ 1124 707 m 16 X s 1564 746 m 10 Y s 1556 756 m 16 X s 1564 701 m -12 Y s 1556 689 m 16 X s 1763 607 m 8 Y s 1756 615 m 15 X s 1763 561 m -10 Y s 1756 551 m 15 X s 0 0.36 1 c 1971 443 1521 731 1527 741 1525 731 1298 684 613 1357 1132 732 1564 724
+ 1763 584 9 { m25} R black 589 1130 m 31 Y s 581 1161 m 15 X s 589 1084 m -39 Y s 581 1045 m 15 X s 865 862 m -1 Y s 857 861 m 15 X s 1 0.2 1 c 589 1107 865 885 1009 758 1028 756 4 { m27} R black 0 0.36 1 c black 0.95 0.95 0.95 c 794 544 1247 1306 bf
+ black 1270 1306 m -15 Y 786 X 536 Y -15 X -521 Y f 1247 1306 m 544 Y 794 X -544 Y -794 X cl s
+ gsave  1442 1792
+ t 0 r 0 0 m /Helvetica findfont 49.4636 sf 0 0 m (Green Pulses Inner Pixels) show  gr  0.2 1 0.2 c 1346 1805 m22 black
+ gsave  1442 1701
+ t 0 r 0 0 m /Helvetica findfont 49.4636 sf 0 0 m (Blue Pulses Inner Pixels) show  gr  0 0.36 1 c 1346 1714 m24 black
+ gsave  1442 1609
+ t 0 r 0 0 m /Helvetica findfont 49.4636 sf 0 0 m (UV Pulses Inner Pixels) show  gr  1 0.2 1 c 1346 1623 m26 black
+ gsave  1442 1518
+ t 0 r 0 0 m /Helvetica findfont 49.4636 sf 0 0 m (Green Pulses Outer Pixels) show  gr  0.2 1 0.2 c 1346 1533 m23 black
+ gsave  1442 1427
+ t 0 r 0 0 m /Helvetica findfont 49.4636 sf 0 0 m (Blue Pulses Outer Pixels) show  gr  0 0.36 1 c 1346 1442 m25 black
+ gsave  1442 1339
+ t 0 r 0 0 m /Helvetica findfont 49.4636 sf 0 0 m (UV Pulses Outer Pixels) show  gr  1 0.2 1 c 1346 1351 m27 black 1 1 1 c 2041 218 23 1948 bf black 23 1948 m 2041 X s 2064 1948 m 218 Y s 2064 2166 m -2041 X s 23 2166 m -218 Y s 1 1 1 c black
+ gsave  91 2001
+ t 0 r 0 0 m /Helvetica-Bold findfont 171.22 sf 0 0 m (All Pixels - Extractor 30) show  gr 
  gr  gr 
 showpage