Index: trunk/MagicSoft/Mars/msignal/MExtractTime.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTime.cc	(revision 5929)
+++ trunk/MagicSoft/Mars/msignal/MExtractTime.cc	(revision 5930)
@@ -195,5 +195,5 @@
     if (IsA()==MExtractTime::Class())
         *fLog << GetDescriptor() << ":" << endl;
-    *fLog << " Offset Lo-Gain: " << fOffsetLoGain << endl;
+    *fLog << " Offset Lo-Gain:     " << fOffsetLoGain << endl;
     MExtractor::Print(o);
 }
Index: trunk/MagicSoft/Mars/msignal/MExtractTimeAndCharge.cc
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTimeAndCharge.cc	(revision 5929)
+++ trunk/MagicSoft/Mars/msignal/MExtractTimeAndCharge.cc	(revision 5930)
@@ -86,5 +86,5 @@
 
 const Float_t MExtractTimeAndCharge::fgLoGainStartShift = -2.8; 
-const Byte_t  MExtractTimeAndCharge::fgMaxBinContentLimit = 100; 
+const Byte_t  MExtractTimeAndCharge::fgLoGainSwitch = 100; 
 // --------------------------------------------------------------------------
 //
@@ -95,5 +95,5 @@
 // - fWindowSizeHiGain and fWindowSizeLoGain to 0
 // - fLoGainStartShift to fgLoGainStartShift+fgOffsetLoGain
-// - fMaxBinContentLimt to fgMaxBinContentLimit
+// - fLoGainSwitch     to fgLoGainSwitch
 //
 MExtractTimeAndCharge::MExtractTimeAndCharge(const char *name, const char *title)
@@ -104,5 +104,5 @@
 
     SetLoGainStartShift();
-    SetMaxBinContentLimit();
+    SetLoGainSwitch();
 }
 
@@ -187,5 +187,5 @@
 
       // Initialize fMaxBinContent for the case, it gets not set by the derived class
-      fMaxBinContent = fMaxBinContentLimit + 1; 
+      fMaxBinContent = fLoGainSwitch + 1; 
 
       const Int_t pixidx = pixel.GetPixelId();
@@ -212,5 +212,5 @@
       // Adapt the low-gain extraction range from the obtained high-gain time
       //
-      if (pixel.HasLoGain() && (fMaxBinContent > fMaxBinContentLimit) )
+      if (pixel.HasLoGain() && (fMaxBinContent > fLoGainSwitch) )
       {
           deltasumlo  = 0; // make logain of MExtractedSignalPix valid
@@ -273,7 +273,7 @@
     }
 
-    if (IsEnvDefined(env, prefix, "MaxBinContentLimit", print))
+    if (IsEnvDefined(env, prefix, "LoGainSwitch", print))
     {
-        fMaxBinContentLimit = GetEnvValue(env, prefix, "MaxBinContentLimit", fMaxBinContentLimit);
+        fLoGainSwitch = GetEnvValue(env, prefix, "LoGainSwitch", fLoGainSwitch);
         rc = kTRUE;
     }
@@ -296,5 +296,5 @@
   
   *fLog << " LoGainStartShift:   " << fLoGainStartShift << endl;
-  *fLog << " MaxBinContentLimit: " << (Int_t)fMaxBinContentLimit << endl;
+  *fLog << " LoGainSwitch:       " << (Int_t)fLoGainSwitch << endl;
   MExtractTime::Print(o);
 }
Index: trunk/MagicSoft/Mars/msignal/MExtractTimeAndCharge.h
===================================================================
--- trunk/MagicSoft/Mars/msignal/MExtractTimeAndCharge.h	(revision 5929)
+++ trunk/MagicSoft/Mars/msignal/MExtractTimeAndCharge.h	(revision 5930)
@@ -12,10 +12,10 @@
 
   static const Float_t fgLoGainStartShift;   // Default for fLoGainStartShift (now set to: -2.8)
-  static const Byte_t  fgMaxBinContentLimit; // Default for fMaxBinContentLimit (now set to: 100)
+  static const Byte_t  fgLoGainSwitch; // Default for fLoGainSwitch (now set to: 100)
   
   Byte_t  fLoGainFirstSave;       //! Temporary variable to store the original position of low-gain start slice
   Float_t fLoGainStartShift;      // Shift to start searching the low-gain signal obtained from the high-gain times.
 
-  Byte_t  fMaxBinContentLimit;    // Limit for max. bin content before the low-gain gets extracted
+  Byte_t  fLoGainSwitch;    // Limit for max. bin content before the low-gain gets extracted
 
 protected:
@@ -36,12 +36,12 @@
   MExtractTimeAndCharge(const char *name=NULL, const char *title=NULL);
   
-  Int_t  GetWindowSizeHiGain  () const { return fWindowSizeHiGain;   }
-  Int_t  GetWindowSizeLoGain  () const { return fWindowSizeLoGain;   }
-  Byte_t GetMaxBinContentLimit() const { return fMaxBinContentLimit; }
+  Int_t  GetWindowSizeHiGain  () const { return fWindowSizeHiGain; }
+  Int_t  GetWindowSizeLoGain  () const { return fWindowSizeLoGain; }
+  Byte_t GetLoGainSwitch      () const { return fLoGainSwitch;     }
 
   void Print(Option_t *o="") const;
   
-  void SetLoGainStartShift( const Float_t f=fgLoGainStartShift )  { fLoGainStartShift = f + fOffsetLoGain;  }
-  void SetMaxBinContentLimit( const Byte_t i=fgMaxBinContentLimit ) { fMaxBinContentLimit = i; }
+  void SetLoGainStartShift( const Float_t f=fgLoGainStartShift ) { fLoGainStartShift = f + fOffsetLoGain;  }
+  void SetLoGainSwitch    ( const Byte_t  i=fgLoGainSwitch     ) { fLoGainSwitch     = i; }
 
   virtual void SetWindowSize(Int_t windowh, Int_t windowl) { fWindowSizeHiGain = windowh;