Index: trunk/MagicSoft/GRB-Proposal/Strategies.tex
===================================================================
--- trunk/MagicSoft/GRB-Proposal/Strategies.tex	(revision 6003)
+++ trunk/MagicSoft/GRB-Proposal/Strategies.tex	(revision 6087)
@@ -1,9 +1,34 @@
 \section{Proposed Observation Strategies}
 
-\ldots {\bf PRODUCE A PLOT WITH THE OVERLAP BETWEEN SWIFT AND MAGIC-- Markus Garcz. } \ldots
+First of all let's consider how many observations are we going to do.\\
 
-\ldots {\bf PRODUCE PLOT WITH ESTIMATION OF MAX. ZENITH ANGLE DEP. ON GAMMA-RAY HORIZON } \ldots
+A rough estimation of the time consume due to GRB observation comes out
+from the claimed GRB observation by SWIFT, of about 150-200 GRBs/year, and
+the results on the studies on the MAGIC duty-cycle made by
+Nicola Galante \cite{GALANTE} and Satoko Mizobuchi \cite{SATOKO}.
+Considering a MAGIC duty-cycle of about 10\% and a tollerance of 5 hours
+to point the GRB, we should be able to point about 1-2 GRB/month. 
+Such duty-cycle studies, made before MAGIC started its observations,
+are reliable as long as weather constraints that were considered
+(~maximum wind's speed of 10 m/s, maximum humidity of 80\% and
+darkness at astronomical horizon~) revealed similar to the real ones that
+are affecting MAGIC's observation time. In this duty-cycle study
+also full moon night are considered usefull (~just requiring
+a minimum angular distance of the GRB from the moon of 30$^\circ$~),
+while 3-4 nights per month are actually skipped because of full moon,
+but this reduction of the real duty-cycle is about compensated
+by the tollerance of 5 hours for considering the alert 
+(~5 hours more before the beginning of the night usefull
+for getting GRB's alerts are equivalent to an increase 
+of the duty-cycle of about 6 days per month~). Actually 
+observation's interruptions due to technical tasks are
+not considered here. \\
 
-\ldots {\bf SIMULATE BURTS AND TRIGGER THEM WITH SWIFT AND MAGIC } \ldots
+All this discussion tells us that, excluding from our
+considerations interruptions of the observing time due to
+technical tasks, MAGIC should employ 1-2 nights per month
+in GRB observations. This means that we must do as much
+as possible to observe them EVERY time that a usefull
+alert occours.
 
 \subsection{What to do with the AMC ? }
@@ -13,5 +38,14 @@
 \subsection{What to do with moon shine ? }
 
-\ldots {\bf NICOLA, HV TABLES, LIDS ... -- CAMERA EXPERTS - ECKART, RAZMIK, MANEL, JOSE} \ldots
+The telescope's slewing in case of a GRB alert will be done
+without closing the camera lids, so that the camera could be
+flashed by the moon during such movement. In principle
+a fast moon-flash shouldn't damage the PMTs, but the behaviour
+of the camera and of the Camera Control {\it guagua} must
+be tested. Otherway, if such test concludes that it is not safe
+at all to get even a short flash from the moon, the possibility
+to implement a new feature into the Steering System wich
+follow a different path while selwing must be considered.
+
 
 \subsection{Calibration }
@@ -19,24 +53,4 @@
 \ldots {\bf MARKUS gAUG} \ldots
 
-\subsection{Maximizing the duty cycle}
-
-\begin{verbatim}
-email Nicola Galante: \\
-\\
-I calculated duty-cycle with a Sun zenith angle greater 
-than 105 deg, which means that Sun must be at least 15 deg below 
-horizon, and not with an angle of 115 deg. I tried this calculation also 
-with a limit of 108 deg, because a lot of people assume that the 
-astronomical sunset is when the Sun is 18 deg below horizon. Using this 
-assumption the calculated duty-cycle decreases of about 4\%(from 1.225 to 
-1.18 srad per year or from 9.75\% to 9.36\% vs 4pi srad per year). Anyway 
-the definition of astronomical sunset influence the main cut on duty-cycle.
-About wind I can say that the data I used were provided by NOT, which is 
-situated in a place more windy than where MAGIC is growing up. I made 
-the calculation also with other upper limits to wind's speed then the 
-usual 10 m/s, and we can gain quite a lot of duty-cycle (even about 
-1.5\%more vs 4pi srad per year) so it should be interesting to test the 
-telescope during some windy or foggy days.
-\end{verbatim}
 
 \subsection{In case of follow-up: Next steps}